# Di Library

This is a multifunctional datapack library for simple uses.

- Author: Minecraft_hyr
- Version: 1.8
- Supported MC versions: 1.20.2

## Feature List

<details><summary style="font-size:18px">English</summary>

### Minecraft files(namespace: minecraft)

- If you want to embed Di Library in your datapack, please add functions in minecraft tag file

### Di Library main files(namespace: dilib)

- Stored some tags & item_modifiers & predicates

- `storage temp:temp`  
  You can put some temp data in this storage  
  Please remove data after use

- `/function dilib:presets/objectives`:

  Load some scoreboard objectives. Some display name is official translate text. Can be used for check statics, but please do not modify these scores

- `/function dilib:presets/const`:  
  **This function will load when install.**  
  Add to the `const` objectives:  
   Integers of -1000..1000, use the corresponding string as a score holder  
   Integers of ±10^<0..9>, ±(10^<0..9>-1), use the corresponding string as a score holder  
   Integers of 2^<0..30>, 2^<0..30>-1, 2^31-1, -2^31, use the corresponding string as a score holder  
   10\*Integers of -1000..10000，-1000..-10000, use the corresponding string as a score holder

  Add into `storage dilib:const`: `pi:3.141592653589793d,tau:6.283185307179586d,e:2.718281828459045d`

- `/function dilib:presets/durability`:  
  Calculate damage to item for unbreaking item.  
  Input:  
  `score damage dilib..input`: Expect damage to item (default: 1)  
  `storage dilib:input item`: Item NBT (`id`,`tag`,`Count`)  
  `storage dilib:input item.slot`: Item slot string for `/item` command

- `/function dilib:presets/explosion`:  
  Explosion selecting location without creeper ghost.  
  Macro:  
  `$(radius)`: NBT `ExplosionRadius`

- `/function dilib:debug`:

  - First execute: Show particles at invisible entity and marker, notification when function loaded.
  - Second execute: Remove all features.

- `#dilib:menus`:

  Execute when `/trigger menus`.  
  Example:

  ```mcfunction
  tellraw @s {"text": "[Minecraft Remade]","clickEvent": {"action": "run_command","value": "/function mc_remade:tag/menu/configs/1"},"hoverEvent": {"action": "show_text","contents": "Click me to config Minecraft Remade"},"color": "green"}
  ```

- `#dilib:new_player`:

  Execute when new player join.

  - `players @s dilib..player_id`: (In world) Player ID
  - `players players dilib..player_id`: Joined player counter

- `#dilib:item_check`:

  - `storage temp:temp 0` Merge from item data

- `#dilib:item_checker`:

  - `@s` select the armor_stand that mainhand has the item
  - `@e[tag=dilib.this,limit=1]` select the item (entity)

- `#dilib:day_changed`:  
   Add your functions in tags to run function every times event happen

  - `stored_day dilib..data`: Last tick day
  - `current_day dilib..data`: Current day

- `#dilib:daytime_changed`:  
   Add your functions in tags to run function every times event happen

  - `stored_daytime dilib..data`: Last tick daytime
  - `current_daytime dilib..data`: Current daytime

- `#dilib:sneak_end`:  
   Add your functions in tags to run function every times event happen

  - `@s dilib..sneak_time`: Player sneak time until end

</details>

<details><summary style="font-size:18px">中文</summary>

### Minecraft 文件(命名空间: minecraft)

- 如果你要把 Di Library 内置在你的数据包里，请在你的对应标签文件中添加函数

### Di Library 主文件(命名空间: dilib)

- 存放了一些标签、物品修饰器、谓词

- `storage temp:temp`  
  你可以将一些缓存数据放在这个 storage 里  
  请在使用前清除你要使用的内容

- `/function dilib:presets/objectives`:  
  加载一些计分板的对象。部分显示出的名称是官方的可翻译文本。可以用来统计数据，但请不要修改这些数据

- `/function dilib:presets/const`:  
  **该功能在安装时会被加载。**  
  向计分板 const 里加入:  
   -1000..1000 的整数，以对应字符串作为的分数持有者  
   10^<0..9>, 10^<0..9>-1 的整数，以对应字符串作为分数持有者  
   2^<0..30>, 2^<0..30>-1, 2^31-1, -2^31 的整数，以对应字符串作为分数持有者  
   -1000..10000，-1000..-10000 的 10 倍整数，以对应字符串作为分数持有者

  - 向 `storage dilib:const` 加入: `pi:3.141592653589793d,tau:6.283185307179586d,e:2.718281828459045d`

- `/function dilib:presets/durability`:  
  计算有耐久附魔的物品耐久  
  输入:  
  `score damage dilib..input`: 预期对物品的伤害 (默认: 1)  
  `storage dilib:input item`: 物品 NBT (`id`, `tag`, `Count`)  
  `storage dilib:input item.slot`: 对 `/item` 命令使用的槽位名称

- `/function dilib:presets/explosion`:  
  在当前位置执行没有苦力怕鬼影的爆炸。  
  宏:  
  `$(radius)`: NBT `ExplosionRadius`

  `/function dilib:debug`:

  - 第一次执行: 每一秒在隐形的实体和标记处显示粒子，函数加载完毕时进行反馈
  - 第二次执行: 清除上述所有特性

- `#dilib:menus`:

  在 `/trigger menus` 时触发。  
  例:

  ```mcfunction
  tellraw @s {"text": "[Minecraft Remade]","clickEvent": {"action": "run_command","value": "/function mc_remade:tag/menu/configs/1"},"hoverEvent": {"action": "show_text","contents": "Click me to config Minecraft Remade"},"color": "green"}
  ```

- `#dilib:new_player`:

  新玩家加入时触发。

  - `dilib:tags/advancements/tick`:

    - `@s dilib..player_id`: （世界）玩家 ID
    - `players dilib..player_id`: 进入过的玩家总数

- `#dilib:item_check`:

  - `storage temp:temp 0`: 缓存了物品数据

- `#dilib:item_checker`:

  - `@s`主手持有物品的盔甲架
  - `@e[tag=dilib.this,limit=1]`选中当前物品（实体）

- `#dilib:day_changed`:

  - `stored_day dilib..data`: 上一刻的日期
  - `current_day dilib..data`: 当前日期

- `#dilib:daytime_changed`:

  - `stored_daytime dilib..data`: 上一刻的今日时间
  - `current_daytime dilib..data`: 当前今日时间

- `#dilib:sneak_end`:

  - `@s sneak_time`: 玩家结束之前的潜行时间

</details>

## Other information

### Planned features

<details>

More features in 1.20.3:

- Math

</details>
